/*
Copyright 2020 The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	zalandoorgv1 "github.com/zalando-incubator/kube-metrics-adapter/pkg/apis/zalando.org/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeScheduledScalings implements ScheduledScalingInterface
type FakeScheduledScalings struct {
	Fake *FakeZalandoV1
	ns   string
}

var scheduledscalingsResource = schema.GroupVersionResource{Group: "zalando.org", Version: "v1", Resource: "scheduledscalings"}

var scheduledscalingsKind = schema.GroupVersionKind{Group: "zalando.org", Version: "v1", Kind: "ScheduledScaling"}

// Get takes name of the scheduledScaling, and returns the corresponding scheduledScaling object, and an error if there is any.
func (c *FakeScheduledScalings) Get(name string, options v1.GetOptions) (result *zalandoorgv1.ScheduledScaling, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(scheduledscalingsResource, c.ns, name), &zalandoorgv1.ScheduledScaling{})

	if obj == nil {
		return nil, err
	}
	return obj.(*zalandoorgv1.ScheduledScaling), err
}

// List takes label and field selectors, and returns the list of ScheduledScalings that match those selectors.
func (c *FakeScheduledScalings) List(opts v1.ListOptions) (result *zalandoorgv1.ScheduledScalingList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(scheduledscalingsResource, scheduledscalingsKind, c.ns, opts), &zalandoorgv1.ScheduledScalingList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &zalandoorgv1.ScheduledScalingList{ListMeta: obj.(*zalandoorgv1.ScheduledScalingList).ListMeta}
	for _, item := range obj.(*zalandoorgv1.ScheduledScalingList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested scheduledScalings.
func (c *FakeScheduledScalings) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(scheduledscalingsResource, c.ns, opts))

}

// Create takes the representation of a scheduledScaling and creates it.  Returns the server's representation of the scheduledScaling, and an error, if there is any.
func (c *FakeScheduledScalings) Create(scheduledScaling *zalandoorgv1.ScheduledScaling) (result *zalandoorgv1.ScheduledScaling, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(scheduledscalingsResource, c.ns, scheduledScaling), &zalandoorgv1.ScheduledScaling{})

	if obj == nil {
		return nil, err
	}
	return obj.(*zalandoorgv1.ScheduledScaling), err
}

// Update takes the representation of a scheduledScaling and updates it. Returns the server's representation of the scheduledScaling, and an error, if there is any.
func (c *FakeScheduledScalings) Update(scheduledScaling *zalandoorgv1.ScheduledScaling) (result *zalandoorgv1.ScheduledScaling, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(scheduledscalingsResource, c.ns, scheduledScaling), &zalandoorgv1.ScheduledScaling{})

	if obj == nil {
		return nil, err
	}
	return obj.(*zalandoorgv1.ScheduledScaling), err
}

// Delete takes name of the scheduledScaling and deletes it. Returns an error if one occurs.
func (c *FakeScheduledScalings) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(scheduledscalingsResource, c.ns, name), &zalandoorgv1.ScheduledScaling{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeScheduledScalings) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(scheduledscalingsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &zalandoorgv1.ScheduledScalingList{})
	return err
}

// Patch applies the patch and returns the patched scheduledScaling.
func (c *FakeScheduledScalings) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *zalandoorgv1.ScheduledScaling, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(scheduledscalingsResource, c.ns, name, pt, data, subresources...), &zalandoorgv1.ScheduledScaling{})

	if obj == nil {
		return nil, err
	}
	return obj.(*zalandoorgv1.ScheduledScaling), err
}
